//////////////////////////////////////////////////
//  Module      : App.h  Version 0.1
//  LastEdit    : 8.6.93
//  Description : Applikation zum Testen der Sprite
//                Routinen 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _APP_H
#define _APP_H

#include <Xm/Xm.h>

#include "Base.h"

class CMySpriteAnimArea;
class CPixmapButton;

//////////////////////////////////////////////////
// CApp 

class CApp : public CBase
{
  protected:

    // Widgets

    Widget         m_wMenuBar;
    Widget         m_wPullDownFile;
    Widget         m_wPushBExit;

    Widget         m_wFrameWorkWindow;
    Widget         m_wFormWorkWindow;
    Widget         m_wFormCmd;
    Widget         m_wRowColumnCmd;    

    CPixmapButton *m_pPixButtonStart;
    CPixmapButton *m_pPixButtonStop;
    CPixmapButton *m_pPixButtonPulse;

    Widget         m_wScaleSpeed;

    // Colormap
    Colormap m_colormap;

    // Animationsbereich

    CMySpriteAnimArea *m_pSpriteAnimArea;

    // Callbacks

    void StartCB(Widget , XtPointer , XtPointer );
    void StopCB(Widget ,  XtPointer , XtPointer );
    void PulseCB(Widget , XtPointer , XtPointer );
    void SpeedCB(Widget , XtPointer , XtPointer );
    void ExitCB(Widget ,  XtPointer , XtPointer );

    // Create...

    void CreateMenuBar();
    void CreateWorkWindow();
    void CreateCommandWindow();

  public:
    CApp(Widget wParent, const char *szName, Colormap colormap);
    ~CApp();
};

#endif // _APP_H
