//////////////////////////////////////////////////
//  Module      : MySpriteAnimArea.C  Version 0.1
//  LastEdit    : 23.5.94
//  Description : Realisierung einer Animation 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#include <stdlib.h>

#include "MySpriteAnimArea.h"

//////////////////////////////////////////////////
// CMySpriteAnimArea:: C M y S p r i t e A n i m A r e a

CMySpriteAnimArea::CMySpriteAnimArea(Widget              wParent, 
                                     const char         *szName,
                                     const char         **pBackground,
                                     const SpriteStructData *spriteObjects,
                                     uint                nNumObjects,
                                     Colormap            colormap) 
  : CSpriteAnimArea(wParent, 
                    szName, 
                    pBackground, 
                    spriteObjects, 
                    nNumObjects, 
                    colormap)
{
  if (Good())
  {
    m_pSprites[0]->Move(CSize(8,0));
    m_pSprites[1]->Move(CSize(-4,4));
    m_pSprites[2]->Move(CSize(4,-4));
  }
  else
  {
    cerr << "Fataler Fehler in <CMyAnimationArea::CMyAnimationArea>"
         << " kann Animationsbereich nicht erzeugen" << endl;

    exit(1);
  }
}
//////////////////////////////////////////////////
// CMySpriteAnimArea:: ~C M y S p r i t e A n i m A r e a  

CMySpriteAnimArea::~CMySpriteAnimArea()
{
}

//////////////////////////////////////////////////
// CMySpriteAnimArea::M o v e S p r i t e s

void CMySpriteAnimArea::MoveSprites()
{
  XSync(XtDisplay(m_wBase), False);

  // Figur 
  if (m_pSprites[0]->Position().x > Width())
  {
    m_pSprites[0]->Move(CSize(-8,0));
  }
  else if (m_pSprites[0]->Position().x < -m_pSprites[0]->Width())
  {
    m_pSprites[0]->Move(CSize(8,0));
  }
  else
  { 
    m_pSprites[0]->Move(m_pSprites[0]->DeltaLastPos());
  }

  // Ball
  CPoint pointPos = MousePos();
  pointPos -= CPoint(m_pSprites[1]->Width() / 2, 
                     m_pSprites[1]->Width() / 2);
  m_pSprites[1]->Position(pointPos);

  // Logo
  if (m_pSprites[2]->Position().y > Height()  ||
      m_pSprites[2]->Position().y < -m_pSprites[2]->Height())
  {
    m_pSprites[2]->Move(CSize(
      m_pSprites[2]->DeltaLastPos().cx, -m_pSprites[2]->DeltaLastPos().cy));
  }
  else if (m_pSprites[2]->Position().x < -m_pSprites[2]->Width() ||
           m_pSprites[2]->Position().x > Width())
  {
    m_pSprites[2]->Move(CSize(
      -m_pSprites[2]->DeltaLastPos().cx, m_pSprites[2]->DeltaLastPos().cy));
  }
  else
  { 
    m_pSprites[2]->Move(m_pSprites[2]->DeltaLastPos());
  }
}
