//////////////////////////////////////////////////
// xmsprite.C: Hauptprogramm
//////////////////////////////////////////////////
#include <iostream.h>
#include <new.h>

#include <Xm/Xm.h>
#include "App.h"

#define APPCLASS "XMsprite"

//////////////////////////////////////////////////
// Fallbackresourcen

static String szFallbackResources[] =
{
  "*file.labelString: \
    App-defaults file not installed or not accesible.",
  "*file.fontList: *helvetica-bold*18*iso8859-1",
  NULL
};
//////////////////////////////////////////////////
// M y N e w H a n d l e r

void MyNewHandler()
{
  char szMessage[] = "Fehler in <MyNewHandler> kein Speicherplatz mehr vorhanden\n";

  // Fehlermeldung auf <stderr> ausgeben
  write (2, szMessage, sizeof(szMessage));

  // Programm mit Fehlerstatus beenden 
  _exit(1);
}

main(int argc, char **argv)
{
  XtAppContext app;
  Widget       wToplevel;

  int          n;

  Colormap     colormap;

  set_new_handler(&MyNewHandler);
  
  wToplevel = XtVaAppInitialize(&app, APPCLASS, NULL, 0,
    &argc, argv, szFallbackResources, NULL);

  // Wenn irgendeine Kommandozeilenoption angegeben wurde, dann
  // benutze eigene Colormap
  if (argc < 2)
  {
    colormap = DefaultColormap(XtDisplay(wToplevel),
      DefaultScreen(XtDisplay(wToplevel)));
  }
  else
  {
    colormap = XCreateColormap(XtDisplay(wToplevel),
      DefaultRootWindow(XtDisplay(wToplevel)),
      DefaultVisual(XtDisplay(wToplevel), DefaultScreen(XtDisplay(wToplevel))),
      AllocNone);
    XtVaSetValues(wToplevel,
      XmNcolormap, colormap,
      NULL);
  }

  CApp *testapp = new CApp(wToplevel, "testApp",colormap); 
  testapp->Show();

  XtRealizeWidget(wToplevel);
  XtAppMainLoop(app);
}
