//////////////////////////////////////////////////
//  Module      : SpriteAnim.h  Version 0.1
//  LastEdit    : 16.5.93
//  Description : Animation von Sprites 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _SPRITE_ANIM_H
#define _SPRITE_ANIM_H

#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include <Xm/DrawingA.h>

#include "Types.h"
#include "Sprite.h"
#include "Array.h"
#include "IntCounter.h"

//////////////////////////////////////////////////
// CSpriteAnim - Klasse zur Animation von Sprites

class CSpriteAnim
{
  protected:
    static GC m_gc;                    // GC zum Kopieren  

  protected:
    CArray<CSprite*> m_sprites;        // Sprites 
    CSize           m_size;            // Groesse Hintergrundbild
    Pixmap          m_pixBackground;   // Hintergrundbild 
    CSize           m_sizeOffscreen;   // Groesse der Hintergrundpixmap
    Pixmap          m_pixOffscreen;    // Hintergrundpixmap 
    Widget          m_widget;          // Widget der Animation
    bool            m_refresh;         // Update des gesamten Fensters
    CIntCounter     m_intcounter;      // Anzahl der Aufrufe von Animate()

  protected:
    void Exposure();
    void ExposureCB(Widget w, XtPointer pClientData, XtPointer pCallData);

  public:
    CSpriteAnim(Widget widget, CSize size, Pixmap background);

    // Sprite der Animation hinzufuegen
    void Add(const CSprite& sprite);

    // Sprite animieren - z.B. ueber Timer aufrufen
    void Animate();
};

#endif // _SPRITE_ANIMATION_H
