//////////////////////////////////////////////////
//  Module      : SpriteTimer.C  Version 0.1
//  LastEdit    : 21.05.94
//  Description : Klasse zur Steuerung der Animation 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#include <assert.h>

#include "SpriteAnimArea.h"
#include "SpriteAnim.h"
#include "SpriteTimer.h"

//////////////////////////////////////////////////
// CSpriteTimer

//////////////////////////////////////////////////
// C S p r i t e T i m e r : : C S p r i t e T i m e r

CSpriteTimer::CSpriteTimer(Widget w, CSpriteAnim* pSpriteAnim, 
  CSpriteAnimArea *pSpriteAnimArea, int nSpeed) 
  : CTimer(w, nSpeed)
{
  assert(pSpriteAnim != NULL);
  assert(pSpriteAnimArea != NULL);

  m_pSpriteAnim = pSpriteAnim;
  m_pSpriteAnimArea = pSpriteAnimArea;
}
//////////////////////////////////////////////////
// C S p r i t e T i m e r : : T i m e r F u n c t i o n 

void CSpriteTimer::TimerFunction()
{
  // Fuehre Bewegung aus.
  m_pSpriteAnimArea->MoveSprites();
  m_pSpriteAnim->Animate();
}

