//////////////////////////////////////////////////
//  Module      : Timer.h  Version 0.1
//  LastEdit    : 21.05.94
//  Description : Timer 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _TIMER_H
#define _TIMER_H

#include <X11/Intrinsic.h>

#include "Types.h"

//////////////////////////////////////////////////
// CTimer - Klasse zur Steuerung von Ablauefen mit
//          einem Timer

class CTimer
{
  protected:
    dword        m_dwDeltaTime;   // Zeit zwischen zwei Aufrufen des Timers [ms]
    uint         m_nSpeed;        // Timer Aufrufe pro Sekunde
    XtIntervalId m_intervallId;   // ID des Timers 

    Widget       m_widget;
  
    void Timer();
    static void TimerCB(XtPointer pClientData, XtIntervalId* id);

  protected:
    virtual void TimerFunction() = 0;

  public:
    CTimer(Widget w, uint nSpeed);
    virtual ~CTimer();

    // Funktionen zur Steuerung des Timers
    virtual void Stop();
    virtual void Start();
    virtual void Pulse();

    // Speed = Anzahl der Aufrufe pro Sekunde 
    virtual void Speed(uint nSpeed);
    virtual uint Speed();
};
  
#endif // _TIMER_H
