//////////////////////////////////////////////////
//  Module      : Base.C  Version 0.1
//  LastEdit    : 29.5.94
//  Description : Basisklasse 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#include <assert.h>

#include "Base.h"

CBase::CBase(const char *szName)
{
  m_wBase = NULL;
  assert(szName != NULL); 
  m_szName = XtNewString(szName);
}  

CBase::~CBase()
{
  if (m_wBase)
    XtDestroyWidget(m_wBase);
  XtFree(m_szName);
}

void CBase::Show()
{
  assert(m_wBase != NULL);
  XtManageChild(m_wBase);
}

void CBase::Hide()
{
  assert(m_wBase != NULL);
  XtUnmanageChild(m_wBase);
}

void CBase::GetResources(const XtResourceList resources,
  const int iNumResources, 
  const ArgList args,
  const Cardinal cardNumArgs)
{
  assert(m_wBase != NULL);
  XtGetSubresources(m_wBase,
    (XtPointer) this,
    m_szName,
    ClassName(),
    resources,
    iNumResources,
    args,
    cardNumArgs);
}
