//////////////////////////////////////////////////
//  Module      : Base.h  Version 0.1
//  LastEdit    : 29.5.94
//  Description : Basisklasse 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _BASE_H
#define _BASE_H

#include <Xm/Xm.h>

class CBase
{
  protected:
    char *m_szName;            

    // Widget-id des Managers
    Widget m_wBase;           

    // Setzen spezieller Resourcen
    void GetResources(const XtResourceList, 
      const int ,              
      const ArgList ,
      const Cardinal cardNumArgs);

    // Konstruktor, protected - verhindert 
    // direkte Instanziierung der Klasse.
    CBase(const char *szName); 

  public: 
    // Destruktor
    virtual ~CBase();  

    // Anzeigen des Elements
    virtual void Show();     
    
    // Lschen des Elements
    virtual void Hide();      

    // Klassenname fr GetResources() 
    virtual const char *const ClassName() { return ("CBase"); }
                               
    const Widget AsWidget() { return (m_wBase); }
};

#endif // _BASE_H 
