//////////////////////////////////////////////////
//  Module      : IntCounter.h  Version 0.1
//  LastEdit    : 23.05.94
//  Description : Integer Zaehler mit Bereichspruefung 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _INT_COUNTER_H
#define _INT_COUNTER_H

#include <iostream.h>

#include "Types.h"

//////////////////////////////////////////////////
// CIntCounter - Zaehler 

class CIntCounter
{
  private:
    short int m_nValue;
    long m_nStartValue;
    long m_nMaxValue;
    short int m_nMinValue;

  public:
    CIntCounter(int nValue = 0);
    
    int operator++ (int); // Postfix Notation
    int operator-- (int); // Postfix Notation
   
    bool operator> (int nValue);
    bool operator< (int nValue);

    uint operator% (int nValue);

    int AsInteger();

    friend ostream& operator<< (ostream& stream, const CIntCounter& cnt);
};

inline CIntCounter::CIntCounter(int nValue)
{
  m_nMaxValue = (1 << sizeof(short)*8) / 2 - 1;
  m_nMinValue = -(m_nMaxValue + 1);  

  m_nValue = nValue;
  m_nStartValue = nValue;
}

inline int CIntCounter::operator++ (int)
{
  if (m_nValue < m_nMaxValue)
    m_nValue++;
  else
    m_nValue = m_nStartValue;
  return m_nValue;
}

inline int CIntCounter::operator-- (int)
{
  if (m_nValue > m_nMinValue)
    m_nValue--;
  else
    m_nValue = m_nStartValue;    
  return m_nValue;
}

inline bool CIntCounter::operator> (int nValue)
{
  return (m_nValue > nValue);
}

inline bool CIntCounter::operator< (int nValue)
{
  return (m_nValue < nValue);
}  

inline uint CIntCounter::operator% (int nValue)
{
  return (m_nValue % nValue);
}

inline int CIntCounter::AsInteger()
{
  return (m_nValue);
}

inline ostream& operator<< (ostream& stream, const CIntCounter& cnt)
{
  cout << "counter: " << cnt.m_nValue;
  return stream;
}
#endif // _INT_COUNTER_H
