//////////////////////////////////////////////////
//  Module      : Point.h  Version 0.1
//  LastEdit    : 16.5.93
//  Description : Klasse fuer Punkte 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _POINT_H
#define _POINT_H

#include <iostream.h>

#include "Types.h"

typedef struct _POINT
{
  int x;
  int y;
} POINT;

#include "Size.h"

//////////////////////////////////////////////////
// CPoint - Klasse fuer Punkte

class CPoint : public _POINT
{
  public:
    CPoint();
    CPoint(int nX, int nY);
    CPoint(POINT point);
    CPoint(SIZE size);

    bool operator== (POINT point) const;
    bool operator!= (POINT point) const;
    void operator+= (POINT point);
    void operator-= (POINT point);  

    CPoint operator+ (POINT point) const;
    CPoint operator- (POINT point) const;
};

inline CPoint::CPoint()
{
  x = 0; y = 0;
}

inline CPoint::CPoint(int nX, int nY)
{
  x = nX; y = nY;
}

inline CPoint::CPoint(POINT point)
{
  x = point.x; y = point.y;
}

inline CPoint::CPoint(SIZE size)
{
  x = size.cx; y = size.cy;
}

inline bool CPoint::operator== (POINT point) const
{
  return (x == point.x && y == point.y); 
}

inline bool CPoint::operator!= (POINT point) const
{
  return (x != point.x || y != point.y);
}

inline void CPoint::operator+= (POINT point)
{
  x += point.x; y += point.y;
}

inline void CPoint::operator-= (POINT point)
{
  x -= point.x; y -= point.y;
}

inline CPoint CPoint::operator+ (POINT point) const
{
  return (CPoint(x + point.x, y + point.y));
}

inline CPoint CPoint::operator- (POINT point) const
{
  return (CPoint(x - point.x, y - point.y));
}

inline ostream& operator<< (ostream& stream, const CPoint& point) 
{
  cout << "x: " << point.x << " y: " << point.y;
  return stream;
}

#endif // _POINT_H
