//////////////////////////////////////////////////
//  Module      : Size.h  Version 0.1
//  LastEdit    : 16.5.93
//  Description : Klasse fuer Groessen 
//  Author      : T.Helbig
//////////////////////////////////////////////////
#ifndef _SIZE_H
#define _SIZE_H

#include <iostream.h>

#include "Types.h"

typedef struct _SIZE
{
  int cx;
  int cy;
} SIZE;

#include "Point.h"

//////////////////////////////////////////////////
// CSize - Klasse fuer Groesse

class CSize : public _SIZE
{
  public:
    CSize();
    CSize(int nCx, int nCy);
    CSize(SIZE size);
    CSize(POINT point);

    bool operator== (SIZE size) const;
    bool operator!= (SIZE size) const;
    void operator+= (SIZE size);
    void operator-= (SIZE size);  

    CSize operator+ (SIZE size) const;
    CSize operator- (SIZE size) const;
};

inline CSize::CSize()
{
  cx = 0; cy = 0;
}

inline CSize::CSize(int nCx, int nCy)
{
  cx = nCx; cy = nCy;
}

inline CSize::CSize(SIZE size)
{
  cx = size.cx; cy = size.cy;
}

inline CSize::CSize(POINT point)
{
  cx = point.x; cy = point.y;
}

inline bool CSize::operator== (SIZE size) const
{
  return (cx == size.cx && cy == size.cy); 
}

inline bool CSize::operator!= (SIZE size) const
{
  return (cx != size.cx || cy != size.cy);
}

inline void CSize::operator+= (SIZE size)
{
  cx += size.cx; cy += size.cy;
}

inline void CSize::operator-= (SIZE size)
{
  cx -= size.cx; cy -= size.cy;
}

inline CSize CSize::operator+ (SIZE size) const
{
  return (CSize(cx + size.cx, cy + size.cy));
}

inline CSize CSize::operator- (SIZE size) const
{
  return (CSize(cx - size.cx, cy - size.cy));
}

inline ostream& operator<< (ostream& stream, const CSize& size)
{
  cout << "Breite: " << size.cx << " Hoehe: " << size.cy;
  return stream;
}

#endif // _SIZE_H
